var DEVICE_TYPE = 0;

cc.game.onStart = function(){
    var sys = cc.sys;
    if(!sys.isNative && document.getElementById("cocosLoading")) //If referenced loading.js, please remove it
        document.body.removeChild(document.getElementById("cocosLoading"));

    // Pass true to enable retina display, on Android disabled by default to improve performance
    cc.view.enableRetina(sys.os === sys.OS_IOS ? true : false);

    // Disable auto full screen on baidu and wechat, you might also want to eliminate sys.BROWSER_TYPE_MOBILE_QQ
    if (sys.isMobile &&
        sys.browserType !== sys.BROWSER_TYPE_BAIDU &&
        sys.browserType !== sys.BROWSER_TYPE_WECHAT) {
        cc.view.enableAutoFullScreen(true);
    }

    cc.view.adjustViewPort(true);

    if(isPad()){
        cc.view.setDesignResolutionSize(1136, 852, cc.ResolutionPolicy.SHOW_ALL);
    }else{
        cc.view.setDesignResolutionSize(winWidth(), 640, cc.ResolutionPolicy.SHOW_ALL);
    }

    loadSize();
    PaddingConfig();

    CalculateConfig(cc.winSize);
    // The game will be resized when browser size change
    cc.view.resizeWithBrowserSize(true);

    //load resources
    cc.director.runScene(new MovieScene());
    // cc.director.runScene(new HomeScene());
//     cc.director.runScene(new SelectScene());

    // cc.director.runScene(new DogScene());
    // cc.director.runScene(new DuckScene());
    // cc.director.runScene(new MonkeyScene());
    // cc.director.runScene(new RabbitScene());
};
cc.game.run();