var Config_Play = null;
var Config_Physics = null;
function PaddingConfig() {
    Config_Play = {
        breathsufAfterType:{
            notype:0,
            shake:1,
            cry:2,
            laugh:3,
            strech:4,
            handup:5,
            look:6
        },
        camera:{
            cameraInPos:cc.p(cc.winSize.width - 80, cc.winSize.height - 80),
            cameraOutPos:cc.p(-1000,3000)
        },
        propType:{
            cloth:1,
            glass:2,
            hat:3
        },
        defaultSkin:{
            monkey:{
                hat:9,
                glass:4,
                cloth:"c"
            },
            rabbit:{
                hat:9,
                glass:4,
                cloth:"c"
            },
            duck:{
                hat:8,
                glass:4,
                cloth:"b"
            },
            dog:{
                hat:9,
                glass:4,
                cloth:"c"
            }
        },
        cloth:{//0-14(e)
            names:["gongzhu","haidao","wuxia","xiaochou","mofa","shuishou","tianshi","shengshi","chushi","emo","jingcha","niuzai","kongbai","mifeng","shengdan"]
        },
        glass:{//0-5(5)
            names:["taohua","laohua","mo","3d","kongbai","baikuang"]
        },
        hat:{//0-11(b)
            names:["haidao","wuxia","xiaochou","mofa","shuishou","shengshi","chushi","emo","jingcha","kongbai","mifeng","shengdan"]
        },
        clothduck:{//0-14(e)
            names:["tianshi","shuishou","wuxia","mofa","xiaochou","mifeng","shengshi","chushi","jingcha","gongzhu","niuzai","kongbai","emo","shengdan","haidao"]
        },
        glassduck:{//0-5(5)
            names:["taohua","laohua","mo","3d","kongbai","baikuang"]
        },
        hatduck:{//0-11(b)
            names:["shuishou","wuxia","mofa","xiaochou","mifeng","shengshi","chushi","jingcha","kongbai","emo","shengdan","haidao"]
        },
        filterSprite:{
            hat:{
                width:280,
                height:200
            },
            glass:{
                width:240,
                height:160
            },
            cloth:{
                width:320,
                height:320
            }
        },
        monkey:{
            hero_position:cc.p(GW2,GH2),
            prop_position:{
                cloth:cc.p(935 + (cc.winSize.width - 1136) / 2,280),
                glass:cc.p(224 + (cc.winSize.width - 1136) / 2,235),
                hat:cc.p(224 + (cc.winSize.width - 1136) / 2,485)
            },
            prop_ok_position:{
                cloth:cc.p(GW2-10,GH2-130),
                hat:cc.p(GW2-7,GH2+200),
                glass:cc.p(GW2-7,GH2+60)
            },
            hate:{
                cloth:["mofa","tianshi","mifeng","gongzhu"],
                hat:["mofa","mifeng"],
                glass:["laohua","taohua"]
            }
        },
        dog:{
            hero_position:cc.p(GW2,GH2),
            prop_position:{
                cloth:cc.p(935 + (cc.winSize.width - 1136) / 2,280),
                glass:cc.p(224 + (cc.winSize.width - 1136) / 2,235),
                hat:cc.p(224 + (cc.winSize.width - 1136) / 2,485)
            },
            prop_ok_position:{
                cloth:cc.p(GW2-10,GH2-130),
                hat:cc.p(GW2-7,GH2+200),
                glass:cc.p(GW2-7,GH2+60)
            },
            hate:{
                cloth:["mofa","mifeng","gongzhu","emo"],
                hat:["mofa","mifeng","emo"],
                glass:["laohua","taohua"]
            }
        },
        rabbit:{
            hero_position:cc.p(GW2,GH2),
            prop_position:{
                cloth:cc.p(935 + (cc.winSize.width - 1136) / 2,280),
                glass:cc.p(224 + (cc.winSize.width - 1136) / 2,235),
                hat:cc.p(224 + (cc.winSize.width - 1136) / 2,485)
            },
            prop_ok_position:{
                cloth:cc.p(GW2-10,GH2-130),
                hat:cc.p(GW2-7,GH2+200),
                glass:cc.p(GW2-7,GH2+60)
            },
            hate:{
                cloth:["chushi","haidao","wuxia","emo"],
                hat:["emo","chushi","wuxia","haidao"],
                glass:["baikuang","laohua"]
            }
        },
        duck:{
            hero_position:cc.p(GW2,GH2-270),
            prop_position:{
                cloth:cc.p(935 + (cc.winSize.width - 1136) / 2,280),
                glass:cc.p(224 + (cc.winSize.width - 1136) / 2,235),
                hat:cc.p(224 + (cc.winSize.width - 1136) / 2,485)
            },
            prop_ok_position:{
                cloth:cc.p(571,190),
                hat:cc.p(558,457),
                glass:cc.p(570,346)
            },
            hate:{
                cloth:["jingcha","emo","haidao","wuxia"],
                hat:["jingcha","emo","haidao","wuxia"],
                glass:["taohua","laohua"]
            }
        }
    };
    Config_Physics = {
        collisionType:{
            cloth:1,
            glass:2,
            hat:3,
            smallwall:4,
            bigwall:5
        },
        collisionGroup:{
            cloth:1,
            glass:2,
            hat:3,
            smallwall:4,
            bigwall:5,
            cloth_glass_hat:6,
            small_largewall:7
        },
        collisionLayer:{
            cloth:1,
            glass:2,
            hat:4,
            smallwall:8,
            bigwall:16
        },
    };
}
