var GlobalHomeLayer = null;
var isRequestPermission = false;
var HomeLayer = cc.Layer.extend({
    couldIn:null,
    parent_check:null,
    recAdItem:null,
    ctor:function () {
        //////////////////////////////
        // 1. super init first
        this._super();
        this.couldIn = false;
        this.parent_check = null;
        GlobalHomeLayer = this;

        var size = cc.winSize;

        this.setAnchorPoint(cc.p(0.5, 0.5));
        this.preloadMonkey();
        
        this.createComponents();
                                
        this.showBeginAnimation();

        this.addBackKeyListener();
        this.getAdConfig();
         addPrivacyPolicyButton(this,"res/menu/return.png")
        if(!isRequestPermission){
           requestPermission();
           isRequestPermission = true;
        }
        return true;
    },
    addBackKeyListener:function(){
        var self = this;
        cc.eventManager.addListener({
            event: cc.EventListener.KEYBOARD,
            onKeyReleased: function(keyCode, event) {
                if (keyCode == cc.KEY.back) {
                    if(self.recLayer){
                        self.recLayer.removeFromParent(true);
                        self.recLayer = null;
                        return;
                    }
                    if(IS_WALL_SHOW){
                        dismissAppWallLayer();
                        return;
                    }

                    if (self.layer_quit) {
                        self.layer_quit.removeFromParent(true);
                        self.layer_quit = null;
                    } else {
                        var ad_item = getQuitAd();
                        //                        var ad_item = ARRY_AD_HOME[1];
                        if(ad_item){
                            self.layer_quit = new QuitAdViewLayer(function(action) {
                                switch (action) {
                                    case "quit":
                                    {
                                        ddStopAllAudios();
                                        self.leaveGame();
                                        quiteGame();
                                        break;
                                    }
                                    case "continue":
                                    {
                                        self.layer_quit.removeFromParent(true);
                                        self.layer_quit = null;
                                        break;
                                    }
                                    default:
                                        break;
                                }
                            }, ad_item);
                        }else{
                            self.layer_quit = new QuitViewLayer(function(action) {
                                switch (action) {
                                    case "quit":
                                    {
                                        ddStopAllAudios();
                                        self.leaveGame();
                                        quiteGame();
                                        break;
                                    }
                                    case "continue":
                                    {
                                        self.layer_quit.removeFromParent(true);
                                        self.layer_quit = null;
                                        break;
                                    }
                                    default:
                                        break;
                                }
                            });
                        }
                        self.addChild(self.layer_quit, 250);
                    }
                }
                else if (keyCode == cc.KEY.menu) {

                }
            }}, this);
    },
    leaveGame:function(){
            this.unscheduleAllCallbacks();
            releaseObj(this.listener_play);
//            releaseObj(this.listener_feedback);
            releaseObj(this.listener_video);

            cc.textureCache.removeAllTextures();
            cc.spriteFrameCache.removeSpriteFrames();
    },
    getAdConfig:function(){
        this.getAdList(function(){
            cc.log("kag AD_ENABLE = " + AD_ENABLE);
            if(AD_ENABLE && recommandEnable() && ARRY_AD_HOME.length != 0){
                this.ad_view = new AdViewLayer(ARRY_AD_HOME, cc.size(140 + gapX() * 2, cc.winSize.height));
                this.addChild(this.ad_view, 350);
            }
        }.bind(this));
    },
    getAdList:function(showAd){
        if(!recommandEnable()){
            AD_ENABLE = false;
            return;
        }
        getAdConfig("http://bb.shoujiduoduo.com/baby/game.php?act=sharelist&rid=10010&ver=1525" + "&isar=" + (cc.sys.os == cc.sys.OS_ANDROID ? 1 : 0), function(){
            var ad_value = cc.sys.localStorage.getItem("KEY_AD_LIST");
            if(ad_value){
                var parse_result = JSON.parse(ad_value);
                AD_ENABLE = parse_result.enable;
                var ad_list = parse_result.list;
                var ad_in_list = parse_result.inads;
                var ad_quit_list = parse_result.quitads;
                if(null != ad_list){
                    var AD_HOME_LIST = new Array(ad_list.length);
                    parseAdList(AD_HOME_LIST, ad_list);
                    ARRY_AD_HOME = filterAdInstall(AD_HOME_LIST, 8);
                    ARRY_AD_WALL = filterAndSortAdList(AD_HOME_LIST,ARRY_AD_HOME);
                }

                if(null != ad_in_list){
                    var AD_IN_LIST = new Array(ad_in_list.length);
                    parseAdList(AD_IN_LIST, ad_in_list);
                    ARRY_AD_IN = filterAdInstall(AD_IN_LIST, 4);
                }

                if(null != ad_quit_list){
                    var AD_QUIT_LIST = new Array(ad_quit_list.length);
                    parseAdList(AD_QUIT_LIST, ad_quit_list);
                    ARRY_AD_QUIT = filterAdInstall(AD_QUIT_LIST, 4);
                }


                showAd();
            }
        });
    },
    preloadMonkey:function(){
        var self = this;
        this.addChild(new CustomLoadingLayer("monkey", 3, function() {
            cc.log("loading finish!!!");
            self.preloadActions();
            self.createTextureNode();
        }), 50);
    },
    preloadActions:function(){
        this.xizhuangAnimation = newAnimationCreate(36,"xizhuang",0.03,1,false);
        this.tianshiAnimation = newAnimationCreate(36,"tianshi",0.03,1,false);
        this.shengdanAnimation = newAnimationCreate(36,"shengdan",0.03,1,false);

        this.mofaJiesuAnimation = newAnimationCreate(19,"mofa_jiesu_",0.03,1,false);
        this.mofaKaishiAnimation = newAnimationCreate(16,"mofa_kaishi_",0.03,1,false);
        this.mofaShuohuaAnimation = newAnimationCreate(4,"mofa_shuohua_",0.12,15,false);

        this.mofaShuohuaAnimation2 = newAnimationCreate(4,"mofa_shuohua_",0.12,6,false);

        this.retainActions();
    },
    retainActions:function(){
        this.xizhuangAnimation.retain();
        this.tianshiAnimation.retain();
        this.shengdanAnimation.retain();
        this.mofaJiesuAnimation.retain();
        this.mofaKaishiAnimation.retain();
        this.mofaShuohuaAnimation.retain();

        this.mofaShuohuaAnimation2.retain();
    },
    releaseActions:function(){
        this.xizhuangAnimation.release();
        this.tianshiAnimation.release();
        this.shengdanAnimation.release();
        this.mofaJiesuAnimation.release();
        this.mofaKaishiAnimation.release();
        this.mofaShuohuaAnimation.release();

        this.mofaShuohuaAnimation2.release();
    },
    createTextureNode:function(){
        this.monkey = createStaticNode("#mofa_kaishi_5.png",GlobalHomeLayer,cc.p(GW-150,170),10);

        this.grass = new cc.Sprite("res/home/grass.png");
        this.grass.couldTouch = false;
        this.grass.x = Config_Home.grass_pos.x+80;
        this.grass.y = Config_Home.grass_pos.y-50;
        this.addChild(this.grass,20);
        
        this.grass.onTouchBegan = function(touch,event){
            var target = event.getCurrentTarget();
            var locationInNode = target.convertToNodeSpace(touch.getLocation());
            var s = target.getContentSize();
            var rect = cc.rect(0, 0, s.width, s.height);
            var self = this;
            if (cc.rectContainsPoint(rect, locationInNode) && this.couldTouch) {
                this.runAction(cc.sequence(
                    cc.scaleTo(0.2,0.9).easing(cc.easeOut(1)),
                    cc.scaleTo(0.2,1).easing(cc.easeIn(1)),
                    cc.scaleTo(0.2,0.9).easing(cc.easeOut(1)),
                    cc.scaleTo(0.2,1).easing(cc.easeIn(1))
                ));
                GlobalHomeLayer.touchhandle();
            }
        }
        registerTouchEventOneByOne(this.grass,true);

        this.monkey.runAction(cc.sequence(
            cc.callFunc(function(){
                this.grass.couldTouch = false;
            }.bind(this)),
            this.mofaKaishiAnimation,
            this.mofaShuohuaAnimation,
            this.mofaJiesuAnimation,
            cc.callFunc(function(){
                this.grass.couldTouch = true;
            }.bind(this))
        ));
        this.scheduleOnce(function(){
            ddPlayEffect("effect","res/K/audio/home/monkey_out.mp3",false);
        }.bind(this),0.2);
        this.scheduleOnce(function(){
            this.couldIn = true;
            // ddStopAllAudios();
            this.audioIdMusic = ddPlayEffect("music","res/K/audio/home/bgmusic.mp3",false);
            this.audioIdMonkey = ddPlayEffect("effect","res/K/audio/home/monkey_speak1.mp3",false);
        }.bind(this),0.4);
    },
    touchhandle:function(){
        var idx = getRand0ToN(2);
        if(idx == 0){
            cc.log("0");
            GlobalHomeLayer.monkey.runAction(cc.sequence(
                cc.callFunc(function(){
                    GlobalHomeLayer.grass.couldTouch = false;
                }),
                GlobalHomeLayer.xizhuangAnimation,
                cc.callFunc(function(){
                    GlobalHomeLayer.grass.couldTouch = true;
                })
            ));
            this.scheduleOnce(function(){
                cc.log("ccc");
                ddPlayEffect("effect","res/K/audio/home/monkey_out.mp3",false);
            }.bind(this),0.2);
        }else if(idx == 1){
            cc.log("1");
            GlobalHomeLayer.monkey.runAction(cc.sequence(
                cc.callFunc(function(){
                    GlobalHomeLayer.grass.couldTouch = false;
                }),
                GlobalHomeLayer.tianshiAnimation,
                cc.callFunc(function(){
                    GlobalHomeLayer.grass.couldTouch = true;
                })
            ));
            this.scheduleOnce(function(){
                cc.log("bbb");
                ddPlayEffect("effect","res/K/audio/home/monkey_out.mp3",false);
            }.bind(this),0.2);
        }else{
            cc.log("2");
            GlobalHomeLayer.monkey.runAction(cc.sequence(
                cc.callFunc(function(){
                    GlobalHomeLayer.grass.couldTouch = false;
                }),
                GlobalHomeLayer.shengdanAnimation,
                cc.callFunc(function(){
                    GlobalHomeLayer.grass.couldTouch = true;
                })
            ));
            this.scheduleOnce(function(){
                cc.log("aaa");
                ddPlayEffect("effect","res/K/audio/home/monkey_out.mp3",false);
            }.bind(this),0.2);
        }
        return true;
    },
    createComponents:function(){
        var background = new cc.Sprite("res/home/background.png");
        background.setAnchorPoint(cc.p(0, 0));
        background.x = 0;
        background.y = 0;
        this.addChild(background);
        resetScale(background);
        
        this.sprite_title = new cc.Sprite("res/home/title.png");
        this.sprite_title.x = Config_Home.title_begin.x;
        this.sprite_title.y = Config_Home.title_begin.y;
        this.sprite_title._setAnchorX(0.5);
        this.sprite_title._setAnchorY(0.1);
        this.sprite_title.setScale(0.95, 1.1);
        this.addChild(this.sprite_title);

         this.recAdItem = getRecAdItem();

        this.sprite_play = new MenuSingleSprite("res/home/play.png");
        this.sprite_play.x = this.recAdItem== null ?cc.winSize.width/2-150:cc.winSize.width/2-240;
        this.sprite_play.y = Config_Home.menu01_begin.y;
        this.addChild(this.sprite_play);

        if(this.recAdItem != null){
            this.sprite_rec= new MenuSingleSprite("res/home/rec.png");
            this.sprite_rec.x = cc.winSize.width/2+240;
            this.sprite_rec.y = Config_Home.menu01_begin.y;
            this.addChild(this.sprite_rec);
        }
        
        this.sprite_video = new MenuSingleSprite("res/home/video.png");
        this.sprite_video.x = this.recAdItem== null ?cc.winSize.width/2+150:cc.winSize.width/2;
        this.sprite_video.y = Config_Home.menu03_begin.y;
        this.addChild(this.sprite_video);

      //  this.addFeedbackMenu();
    },
    addFeedbackMenu:function(){
        var self = this;
        var feedbackItem = new cc.MenuItemImage(
            "res/feedback/feedback.png",
            "res/feedback/feedback.png",
            function () {
                if (!self.parent_check) {
                    self.parent_check = new ParentCheckLayer(
                        function() {
                    	    cc.log("answer wrong!!!");
                    		if (self.parent_check) {
                    		    self.parent_check.removeFromParent(true);
                    			self.parent_check = null;
                    		}
                    	},
                    	function() {
                    	    cc.log("answer right!!!");
                    		self.parent_check.removeFromParent(true);
                    		self.parent_check = null;
                    		showFeedback();
                    	}
                    );
                    self.addChild(self.parent_check, 250);
                 }
            }, this);
        feedbackItem.attr({
            x: cc.winSize.width  - 100,
            y: cc.winSize.height - 100,
            anchorX: 0.5,
            anchorY: 0.5
        });
        var menu = new cc.Menu(feedbackItem);
        menu.x = 0;
        menu.y = 0;
        this.addChild(menu,65535);
    },
    showBeginAnimation:function(){
        var move_duration = 0.21;
        
        this.sprite_title.runAction(cc.sequence(
            cc.moveTo(0.2, Config_Home.title_end).easing(cc.easeInOut(3)),
            cc.scaleBy(move_duration / 4, 1.15, 0.85),
            cc.scaleTo(move_duration / 4, 1, 1),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 15)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -15)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 10)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -10)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 5)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -5)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -3))
            ));
        
        this.sprite_play.runAction(cc.sequence(
            cc.delayTime(0.4),
            cc.moveTo(0.3,cc.p(this.sprite_play.x, Config_Home.menu01_end.y)).easing(cc.easeInOut(3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 9)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -9)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 6)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -6)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -3)),
            cc.callFunc(function() {
                this.sprite_play.runAction(cc.repeatForever(cc.sequence(
                    cc.scaleTo(0.8, 1.05, 1.05),
                    cc.scaleTo(0.8, 0.95, 0.95))));
                }.bind(this))
        ));
        
        this.sprite_video.runAction(cc.sequence(
            cc.delayTime(0.8),
            cc.moveTo(0.4,cc.p(this.sprite_video.x, Config_Home.menu03_end.y)).easing(cc.easeInOut(3)),
            cc.callFunc(function() {
                this.addListener();
            }.bind(this)),
            cc.moveBy(move_duration, cc.p(0, 9)),
            cc.callFunc(function() {
//                this.showMonkey("speak1", 2);
            }.bind(this)),
            cc.moveBy(move_duration, cc.p(0, -9)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 6)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -6)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, 3)),
            cc.moveBy(move_duration * 2 / 3, cc.p(0, -3)),
            cc.callFunc(function() {
                this.sprite_video.runAction(cc.repeatForever(cc.sequence(cc.scaleTo(0.8, 1.05, 1.05), cc.scaleTo(0.8, 0.95, 0.95))));
            }.bind(this))
        ));

        if(this.sprite_rec){
         this.sprite_rec.runAction(cc.sequence(
                    cc.delayTime(1.2),
                    cc.moveTo(0.4,cc.p(this.sprite_rec.x, Config_Home.menu03_end.y)).easing(cc.easeInOut(3)),
                    cc.callFunc(function() {
                    }.bind(this)),
                    cc.moveBy(move_duration, cc.p(0, 9)),
                    cc.callFunc(function() {
        //                this.showMonkey("speak1", 2);
                    }.bind(this)),
                    cc.moveBy(move_duration, cc.p(0, -9)),
                    cc.moveBy(move_duration * 2 / 3, cc.p(0, 6)),
                    cc.moveBy(move_duration * 2 / 3, cc.p(0, -6)),
                    cc.moveBy(move_duration * 2 / 3, cc.p(0, 3)),
                    cc.moveBy(move_duration * 2 / 3, cc.p(0, -3)),
                    cc.moveBy(move_duration * 2 / 3, cc.p(0, 3)),
                    cc.moveBy(move_duration * 2 / 3, cc.p(0, -3)),
                    cc.callFunc(function() {
                        this.sprite_rec.runAction(cc.repeatForever(cc.sequence(cc.scaleTo(0.8, 1.05, 1.05), cc.scaleTo(0.8, 0.95, 0.95))));
                    }.bind(this))
                ));
        }
    },
    addListener:function(){
        var self = this;
        var sprite_listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                var target = event.getCurrentTarget();
                var locationInNode = target.convertToNodeSpace(touch.getLocation());
              
                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);
              
                if (cc.rectContainsPoint(rect, locationInNode)) {
                    if(target == self.sprite_play){
                        cc.log("play is selected!!!");
                        if (!self.sprite_play.isEnable()) {
                            return false;
                        }
                        self.sprite_play.setEnable(false);
                        self.scheduleOnce(function() {
                            GlobalHomeLayer.monkey.stopAllActions();
                            ddStopAllAudios();

                            cc.director.pushScene(new SelectScene());
                        }, 0.2);
                    } else if(target == self.sprite_video){
                        cc.log("video is selected!!!");
                        if (!self.sprite_video.isEnable()) {
                            return false;
                        }
                        self.sprite_video.setEnable(false);
                        ddStopAllAudios();
                        playVideo();
                        self.sprite_video.setEnable(true);
                        GlobalHomeLayer.monkey.stopAllActions();
                        GlobalHomeLayer.monkey.setTexture("res/K/xizhuang36.png");
                        GlobalHomeLayer.grass.couldTouch = true;
                    }else if(target == self.sprite_rec){
                        cc.log("RecAdViewLayer");
                        if(isInstall(self.recAdItem.getArUrl())){
                            openMarket(self.recAdItem);
                        }else{
                            self.recLayer = new RecAdViewLayer();
                            self.addChild(self.recLayer);
                            setAllNodeZOrder(self.recLayer,1000);
                        }

                    }
                    return true;
                }
                return false;
            },
            onTouchMoved: function (touch, event) {
              
            },
            onTouchEnded: function (touch, event) {
              
            }
        });
        
        this.listener_play = sprite_listener.clone();
        this.listener_play.retain();
        this.listener_video = sprite_listener.clone();
        this.listener_video.retain();
//        this.listener_feedback = sprite_listener.clone();
//        this.listener_feedback.retain();

        if(this.sprite_rec){
            this.listener_rec = sprite_listener.clone();
            this.listener_rec.retain();
            cc.eventManager.addListener(this.listener_rec, this.sprite_rec);
        }
        cc.eventManager.addListener(this.listener_play, this.sprite_play);
        cc.eventManager.addListener(this.listener_video, this.sprite_video);
//        cc.eventManager.addListener(this.listener_feedback, this.sprite_feedback);
    },
    onEnterTransitionDidFinish:function(){
        this.sprite_play.setEnable(true);
        this.sprite_video.setEnable(true);

        if(this.couldIn){
            // ddStopAllAudios();
            ddPlayEffect("music","res/K/audio/home/bgmusic.mp3",true);
            // ddPlayEffect("music","res/K/audio/home/monkey_speak2.mp3",false);
            this.audioId = ddPlayEffect("effect","res/K/audio/home/monkey_speak2.mp3",false);
            this.monkey.runAction(cc.sequence(
                cc.callFunc(function(){
                    this.grass.couldTouch = false;
                }.bind(this)),
                this.mofaKaishiAnimation,
                this.mofaShuohuaAnimation2,
                this.mofaJiesuAnimation,
                cc.callFunc(function(){
                    this.grass.couldTouch = true;
                }.bind(this))
            ));
        }
    },
    onExitTransitionDidStart:function(){
        ddStopAllAudios();
    },
});

var HomeScene = cc.Scene.extend({
    ctor:function () {
        this._super();
        var layer = new HomeLayer();
        this.addChild(layer);
    }
});

